Clinical Reference Bands in JavaScript

Using ApexCharts with JavaScript

This Clinical Reference Bands example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
// Twelve patients, one reference range: the 60-100 bpm normal band is
// declared ONCE on the host and drawn in every panel, projected through the
// shared scale, so no panel's band can ever be wrong. A second annotation
// carries `scope: 'P-07'`: the medication event line appears only in that
// patient's panel. Hover anywhere: `tooltip: 'grid'` shows ONE card with
// every patient's reading at the hovered hour.
//
// Deterministic vitals so the e2e snapshot is stable.
function mulberry32(seed) {
  return function () {
    seed |= 0
    seed = (seed + 0x6d2b79f5) | 0
    var t = Math.imul(seed ^ (seed >>> 15), 1 | seed)
    t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
    return ((t ^ (t >>> 14)) >>> 0) / 4294967296
  }
}

var T0 = new Date('01 Jan 2025').getTime()

function heartRate(seed, base, tachyFrom) {
  var rand = mulberry32(seed)
  var out = []
  var ts = T0
  var val = base
  for (var i = 0; i < 48; i++) {
    val += (rand() - 0.5) * 6
    var v = val
    // P-07 trends tachycardic until the 30h medication event pulls it back.
    if (tachyFrom && i >= tachyFrom && i < 30) v = val + 28
    if (tachyFrom && i >= 30) v = val + Math.max(0, 28 - (i - 30) * 3)
    out.push([ts, Math.round(v)])
    ts += 3600000 // hourly
  }
  return out
}

var patientSeries = []
for (var p = 1; p <= 12; p++) {
  var id = 'P-' + (p < 10 ? '0' + p : p)
  patientSeries.push({
    name: 'Heart rate',
    patient: id,
    data: heartRate(p * 7, 68 + (p % 5) * 4, p === 7 ? 12 : 0),
  })
}

var options = {
  series: patientSeries,
  chart: {
    id: 'vitalsTrellis',
    type: 'line',
    animations: {
      enabled: false,
    },
  },
  trellis: {
    by: 'patient',
    minPanelWidth: 240,
    panelHeight: 130,
    gap: 12,
    tooltip: 'grid',
  },
  colors: ['#0F766E'],
  stroke: {
    width: 2,
    curve: 'straight',
  },
  annotations: {
    yaxis: [
      {
        y: 60,
        y2: 100,
        fillColor: '#22C55E',
        opacity: 0.1,
      },
    ],
    xaxis: [
      {
        x: new Date('01 Jan 2025').getTime() + 30 * 3600000,
        scope: 'P-07',
        borderColor: '#D97706',
        strokeDashArray: 4,
        label: {
          text: 'medication',
          orientation: 'horizontal',
          style: {
            color: '#92400E',
            background: '#FEF3C7',
            fontSize: '10px',
          },
        },
      },
    ],
  },
  xaxis: {
    type: 'datetime',
  },
  yaxis: {
    labels: {
      formatter: function (val) {
        return Math.round(val) + ' bpm'
      },
    },
  },
  dataLabels: {
    enabled: false,
  },
  tooltip: {
    x: {
      format: 'dd MMM HH:mm',
    },
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Clinical Reference Bands in Vue

Using ApexCharts with Vue

This Clinical Reference Bands example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div class="wrap">
      <h1>Patient vitals, one reference range</h1>
      <p class="lead">
        The normal band is declared once and drawn in all twelve panels, so the
        question "who is outside the range" is answered by looking, and P-07's
        tachycardia is unmissable. Hover anywhere: one card reads every patient
        at the same hour.
      </p>

      <div class="chart-wrap">
        <div id="chart">
          <apexchart
            type="line"
            :options="chartOptions"
            :series="series"
          ></apexchart>
        </div>
      </div>

      <div class="note">
        A trellis-scoped annotation is declared once on the host and projected
        into every panel through each panel's own scale, so twelve
        hand-annotated charts collapse into one
        <code>annotations.yaxis</code> entry. An annotation with
        <code>scope: 'P-07'</code> draws only in that patient's panel (the
        medication event). <code>trellis.tooltip: 'grid'</code>
        composes ONE tooltip card with one row per panel at the hovered hour,
        honoring the y formatter, and works even on panels a virtualized grid
        has not mounted. Trellis is a premium feature; without a license it
        renders with a trial watermark.
      </div>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

import 'apexcharts/features/trellis'

// Twelve patients, one reference range: the 60-100 bpm normal band is
// declared ONCE on the host and drawn in every panel, projected through the
// shared scale, so no panel's band can ever be wrong. A second annotation
// carries `scope: 'P-07'`: the medication event line appears only in that
// patient's panel. Hover anywhere: `tooltip: 'grid'` shows ONE card with
// every patient's reading at the hovered hour.
//
// Deterministic vitals so the e2e snapshot is stable.
function mulberry32(seed) {
  return function () {
    seed |= 0
    seed = (seed + 0x6d2b79f5) | 0
    var t = Math.imul(seed ^ (seed >>> 15), 1 | seed)
    t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
    return ((t ^ (t >>> 14)) >>> 0) / 4294967296
  }
}

var T0 = new Date('01 Jan 2025').getTime()

function heartRate(seed, base, tachyFrom) {
  var rand = mulberry32(seed)
  var out = []
  var ts = T0
  var val = base
  for (var i = 0; i < 48; i++) {
    val += (rand() - 0.5) * 6
    var v = val
    // P-07 trends tachycardic until the 30h medication event pulls it back.
    if (tachyFrom && i >= tachyFrom && i < 30) v = val + 28
    if (tachyFrom && i >= 30) v = val + Math.max(0, 28 - (i - 30) * 3)
    out.push([ts, Math.round(v)])
    ts += 3600000 // hourly
  }
  return out
}

var patientSeries = []
for (var p = 1; p <= 12; p++) {
  var id = 'P-' + (p < 10 ? '0' + p : p)
  patientSeries.push({
    name: 'Heart rate',
    patient: id,
    data: heartRate(p * 7, 68 + (p % 5) * 4, p === 7 ? 12 : 0),
  })
}

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: patientSeries,
      chartOptions: {
        chart: {
          id: 'vitalsTrellis',
          type: 'line',
          animations: {
            enabled: false,
          },
        },
        trellis: {
          by: 'patient',
          minPanelWidth: 240,
          panelHeight: 130,
          gap: 12,
          tooltip: 'grid',
        },
        colors: ['#0F766E'],
        stroke: {
          width: 2,
          curve: 'straight',
        },
        annotations: {
          yaxis: [
            {
              y: 60,
              y2: 100,
              fillColor: '#22C55E',
              opacity: 0.1,
            },
          ],
          xaxis: [
            {
              x: new Date('01 Jan 2025').getTime() + 30 * 3600000,
              scope: 'P-07',
              borderColor: '#D97706',
              strokeDashArray: 4,
              label: {
                text: 'medication',
                orientation: 'horizontal',
                style: {
                  color: '#92400E',
                  background: '#FEF3C7',
                  fontSize: '10px',
                },
              },
            },
          ],
        },
        xaxis: {
          type: 'datetime',
        },
        yaxis: {
          labels: {
            formatter: function (val) {
              return Math.round(val) + ' bpm'
            },
          },
        },
        dataLabels: {
          enabled: false,
        },
        tooltip: {
          x: {
            format: 'dd MMM HH:mm',
          },
        },
      },
    }
  },
}
</script>

<style>
body {
  font-family:
    -apple-system, BlinkMacSystemFont, 'Segoe UI', Roboto, sans-serif;
  background: #fafbfc;
  color: #2c3e50;
  margin: 0;
  padding: 32px 16px;
}
.wrap {
  max-width: 1040px;
  margin: 0 auto;
}
h1 {
  font-size: 22px;
  margin: 0 0 8px;
}
.lead {
  color: #5b6b78;
  line-height: 1.5;
  margin: 0 0 20px;
}
.chart-wrap {
  background: #fff;
  border-radius: 8px;
  padding: 16px;
  box-shadow: 0 2px 10px rgba(0, 0, 0, 0.04);
}
.note {
  background: #f0fdf4;
  border-left: 3px solid #16a34a;
  padding: 12px 16px;
  font-size: 13px;
  color: #333;
  border-radius: 2px;
  line-height: 1.6;
  margin: 26px auto 0;
}
.note code {
  background: #dcfce7;
  padding: 1px 5px;
  border-radius: 3px;
}
</style>

Clinical Reference Bands in Angular

Using ApexCharts with Angular

This Clinical Reference Bands example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  private mulberry32 = (seed: any): any => {
        return function () {
          seed |= 0
          seed = (seed + 0x6d2b79f5) | 0
          var t = Math.imul(seed ^ (seed >>> 15), 1 | seed)
          t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
          return ((t ^ (t >>> 14)) >>> 0) / 4294967296
        }
      };

  private T0: any = new Date('01 Jan 2025').getTime();

  private heartRate = (seed: any, base: any, tachyFrom: any): any => {
        var rand = this.mulberry32(seed)
        var out = []
        var ts = this.T0
        var val = base
        for (var i = 0; i < 48; i++) {
          val += (rand() - 0.5) * 6
          var v = val
          // P-07 trends tachycardic until the 30h medication event pulls it back.
          if (tachyFrom && i >= tachyFrom && i < 30) v = val + 28
          if (tachyFrom && i >= 30) v = val + Math.max(0, 28 - (i - 30) * 3)
          out.push([ts, Math.round(v)])
          ts += 3600000 // hourly
        }
        return out
      };

  private patientSeries: any = [];

  public chartOptions: Partial<ChartOptions> = {
          series: this.patientSeries,
          chart: {
            id: 'vitalsTrellis',
            type: 'line',
            animations: {
              enabled: false,
            },
          },
          trellis: {
            by: 'patient',
            minPanelWidth: 240,
            panelHeight: 130,
            gap: 12,
            tooltip: 'grid',
          },
          colors: ['#0F766E'],
          stroke: {
            width: 2,
            curve: 'straight',
          },
          annotations: {
            yaxis: [
              {
                y: 60,
                y2: 100,
                fillColor: '#22C55E',
                opacity: 0.1,
              },
            ],
            xaxis: [
              {
                x: new Date('01 Jan 2025').getTime() + 30 * 3600000,
                scope: 'P-07',
                borderColor: '#D97706',
                strokeDashArray: 4,
                label: {
                  text: 'medication',
                  orientation: 'horizontal',
                  style: {
                    color: '#92400E',
                    background: '#FEF3C7',
                    fontSize: '10px',
                  },
                },
              },
            ],
          },
          xaxis: {
            type: 'datetime',
          },
          yaxis: {
            labels: {
              formatter: (val) => {
                return Math.round(val) + ' bpm'
              },
            },
          },
          dataLabels: {
            enabled: false,
          },
          tooltip: {
            x: {
              format: 'dd MMM HH:mm',
            },
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
    for (var p = 1; p <= 12; p++) {
          var id = 'P-' + (p < 10 ? '0' + p : p)
          this.patientSeries.push({
            name: 'Heart rate',
            patient: id,
            data: this.heartRate(p * 7, 68 + (p % 5) * 4, p === 7 ? 12 : 0),
          })
        }
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Clinical Reference Bands in React

Using ApexCharts with React

This Clinical Reference Bands example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

import 'apexcharts/features/trellis'

// Twelve patients, one reference range: the 60-100 bpm normal band is
// declared ONCE on the host and drawn in every panel, projected through the
// shared scale, so no panel's band can ever be wrong. A second annotation
// carries `scope: 'P-07'`: the medication event line appears only in that
// patient's panel. Hover anywhere: `tooltip: 'grid'` shows ONE card with
// every patient's reading at the hovered hour.
//
// Deterministic vitals so the e2e snapshot is stable.
function mulberry32(seed) {
  return function () {
    seed |= 0
    seed = (seed + 0x6d2b79f5) | 0
    var t = Math.imul(seed ^ (seed >>> 15), 1 | seed)
    t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
    return ((t ^ (t >>> 14)) >>> 0) / 4294967296
  }
}

var T0 = new Date('01 Jan 2025').getTime()

function heartRate(seed, base, tachyFrom) {
  var rand = mulberry32(seed)
  var out = []
  var ts = T0
  var val = base
  for (var i = 0; i < 48; i++) {
    val += (rand() - 0.5) * 6
    var v = val
    // P-07 trends tachycardic until the 30h medication event pulls it back.
    if (tachyFrom && i >= tachyFrom && i < 30) v = val + 28
    if (tachyFrom && i >= 30) v = val + Math.max(0, 28 - (i - 30) * 3)
    out.push([ts, Math.round(v)])
    ts += 3600000 // hourly
  }
  return out
}

var patientSeries = []
for (var p = 1; p <= 12; p++) {
  var id = 'P-' + (p < 10 ? '0' + p : p)
  patientSeries.push({
    name: 'Heart rate',
    patient: id,
    data: heartRate(p * 7, 68 + (p % 5) * 4, p === 7 ? 12 : 0),
  })
}

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: patientSeries,
    options: {
      chart: {
        id: 'vitalsTrellis',
        type: 'line',
        animations: {
          enabled: false,
        },
      },
      trellis: {
        by: 'patient',
        minPanelWidth: 240,
        panelHeight: 130,
        gap: 12,
        tooltip: 'grid',
      },
      colors: ['#0F766E'],
      stroke: {
        width: 2,
        curve: 'straight',
      },
      annotations: {
        yaxis: [
          {
            y: 60,
            y2: 100,
            fillColor: '#22C55E',
            opacity: 0.1,
          },
        ],
        xaxis: [
          {
            x: new Date('01 Jan 2025').getTime() + 30 * 3600000,
            scope: 'P-07',
            borderColor: '#D97706',
            strokeDashArray: 4,
            label: {
              text: 'medication',
              orientation: 'horizontal',
              style: {
                color: '#92400E',
                background: '#FEF3C7',
                fontSize: '10px',
              },
            },
          },
        ],
      },
      xaxis: {
        type: 'datetime',
      },
      yaxis: {
        labels: {
          formatter: function (val) {
            return Math.round(val) + ' bpm'
          },
        },
      },
      dataLabels: {
        enabled: false,
      },
      tooltip: {
        x: {
          format: 'dd MMM HH:mm',
        },
      },
    },
  })

  return (
    <div>
      <div className="wrap">
        <h1>Patient vitals, one reference range</h1>
        <p className="lead">
          The normal band is declared once and drawn in all twelve panels, so
          the question "who is outside the range" is answered by looking, and
          P-07's tachycardia is unmissable. Hover anywhere: one card reads every
          patient at the same hour.
        </p>

        <div className="chart-wrap">
          <div id="chart">
            <ReactApexChart
              options={state.options}
              series={state.series}
              type="line"
            />
          </div>
        </div>

        <div className="note">
          A trellis-scoped annotation is declared once on the host and projected
          into every panel through each panel's own scale, so twelve
          hand-annotated charts collapse into one <code>annotations.yaxis</code>{' '}
          entry. An annotation with <code>scope: 'P-07'</code> draws only in
          that patient's panel (the medication event).{' '}
          <code>trellis.tooltip: 'grid'</code>
          composes ONE tooltip card with one row per panel at the hovered hour,
          honoring the y formatter, and works even on panels a virtualized grid
          has not mounted. Trellis is a premium feature; without a license it
          renders with a trial watermark.
        </div>
      </div>
    </div>
  )
}

export default ApexChart